progress.bar=function(i,j,col="red",title="Progress bar")
{
	require(tcltk) || stop("tcl/tk library not available")

	if(exists(".progbar") && i<=0) tkdestroy(.progbar)

	#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	if(!exists(".progbar") || i<=0)
	{	.progbar.del<<-function()
		{	for (obj in c(".progbar",".progbar.fun",".progbar.canvas",".statusbar.Old",".progbar.par"))
			{	if(!exists(obj,where=globalenv())) next()
				rm(list=obj,envir=globalenv())
			}
		}

		.progbar.fun<<-function(i,j,col,title)
		{	p=max(0,min(1,i/max(1,j)))
                

			percnt=as.integer(p*100+.5)
			if(percnt>0 && percnt<100) tktitle(.progbar) <- paste(title,": ",percnt,"% ready",sep="")
			else if( percnt==0) tktitle(.progbar) <- title
			else tktitle(.progbar) <- paste(title,": ready",sep="")
                
			if(i>j) tkdestroy(.progbar)
			else {	cb=.progbar.par["borderwidth"]
			 	xup=as.integer(.progbar.par["width"]*p+.5)
			        statusbar=tkcreate(.progbar.canvas,"rect",1+cb,1+cb,xup+cb,
									.progbar.par["height"]+cb,
									width=1,fill=col)
				if(exists(".statusbar.Old") && !is.null(.statusbar.Old)) tkdelete(.progbar.canvas, "withtag", .statusbar.Old)
				.statusbar.Old<<-statusbar
		
				tkraise(.progbar)
				tkfocus(.progbar)		
				Sys.sleep(0.01)
			}
		 	return(invisible(NULL))
		}

		#................................................................................

		.progbar	<<- tktoplevel()

		tktitle(.progbar)<- title

		.progbar.par<<-c(width=400,height=20,borderwidth=2)

		.progbar.canvas<<-tkcanvas(.progbar,width=.progbar.par["width"],
						height=.progbar.par["height"],
						borderwidth=.progbar.par["borderwidth"],
						relief="sunken")
	      	tkgrid(.progbar.canvas)
		tkbind(.progbar,"<Destroy>", .progbar.del)
	}
	#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	.progbar.fun(i,j,col,title)

	return(invisible(NULL))
}
