#
#setMethod("summary",signature="tle",function(fit)summary.gte(fit))
#setMethod("coef",signature="tle",function(fit)coef.gte(fit))

summary.gte=function(est.gte){
	if(length(grep("tle",class(est.gte)))>0) {
		cat(	"\n GTE estimation detailes",
			"\n ===================================",
			"\n kTrim      \t=",est.gte$kTrim,
			"\n k*	       \t=",est.gte$kS,
			"\n maxloglik  \t=",est.gte$maxloglik,
			"\n best       \t=",est.gte$indbest,
			"\n outliers   \t=",est.gte$indout,
			"\n iter best  \t=",est.gte$iterbest,
			"\n iter       \t=",est.gte$it,
			"\n successful \t=",est.gte$sit,
			"\n tleweights \t=",est.gte$tleweights,
			"\n tlemem     \t=",est.gte$tlemem,
			"\n (ranked)   \t=",sort(est.gte$tlemem,index=T)$ix,
			"\n\n")
		print(summary(est.gte$estimate))
		if(!is.null(est.gte$estimate$dispersion.fit)) print(summary(est.gte$estimate$dispersion.fit))
	} else print("This is not a 'tle' class estimate!")
	return(invisible(NULL))
}

coef.gte=function(est.gte) {
	coef=NULL
	if(length(grep("tle",class(est.gte)))>0) coef=coef(est.gte$estimate)
	return(invisible(coef))
}
